<?php

#########################################################
#                                                       #
#  CC / CREDIT CARD payment method class                #
#  This module is used for real time processing of      #
#  Credit card data of customers.                       #
#                                                       #
#  Copyright (c) 2009 Novalnet AG                       #
#                                                       #
#  Released under the GNU General Public License        #
#  novalnet_cc module Created By Dixon Rajdaniel        #
#  This free contribution made by request.              #
#  If you have found this script usefull a small        #
#  recommendation as well as a comment on merchant form #
#  would be greatly appreciated.                        #
#                                                       #
#  Version : novalnet_cc.php vOscCC1.3.1 2009-03-01     #
#                                                       #
#########################################################


class novalnet_cc {


  var $code;
  var $title;
  var $description;
  var $enabled;

  function novalnet_cc() {
    global $order;

    $this->code = 'novalnet_cc';
    $this->title = MODULE_PAYMENT_NOVALNET_CC_TEXT_TITLE;
    $this->public_title = MODULE_PAYMENT_NOVALNET_CC_TEXT_PUBLIC_TITLE;
    $this->description = MODULE_PAYMENT_NOVALNET_CC_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_PAYMENT_NOVALNET_CC_SORT_ORDER;
    $this->enabled = ((MODULE_PAYMENT_NOVALNET_CC_STATUS == 'True') ? true : false);

    if ((int)MODULE_PAYMENT_NOVALNET_CC_ORDER_STATUS_ID > 0) {
      $this->order_status = MODULE_PAYMENT_NOVALNET_CC_ORDER_STATUS_ID;
    }

    if (is_object($order)) $this->update_status();
  }
  
  ### calculate zone matches and flag settings to determine whether this module should display to customers or not ###
  function update_status() {
    global $order;

    if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_NOVALNET_CC_ZONE > 0) ) {
      $check_flag = false;
      $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_NOVALNET_CC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    }
  }
  
  ### JS validation which does error-checking of data-entry if this module is selected for use ###
  ### the fields to be cheked are (Bank Owner, Bank Account Number and Bank Code Lengths)      ###
  ### currently this function is not in use ###
  // @return string
  function javascript_validation() {
    return false;
  }
  
  ### Builds set of input fields for collecting Bankdetail info ###
  // @return array
  function selection() {
    global $order, $HTTP_POST_VARS, $_POST;

    $onFocus = '';
    if(count($HTTP_POST_VARS)==0 || $HTTP_POST_VARS=='') $HTTP_POST_VARS = $_POST;

    $cc_no = $HTTP_POST_VARS['cc_no'];
    if(!$cc_no){$cc_no=$_SESSION['cc_no'];}
    $cc_exp_month = $HTTP_POST_VARS['cc_exp_month'];
    if(!$cc_exp_month){$cc_exp_month=$_SESSION['cc_exp_month'];}
    $cc_exp_year = $HTTP_POST_VARS['cc_exp_year'];
    if(!$cc_exp_year){$cc_exp_year=$_SESSION['cc_exp_year'];}
    $cc_cvc2 = $HTTP_POST_VARS['cc_cvc2'];
    if(!$cc_cvc2){$cc_cvc2=$_SESSION['cc_cvc2'];}
    $cc_holder = $HTTP_POST_VARS['cc_holder'];
    if(!$cc_holder){$cc_holder=$_SESSION['cc_holder'];}
    if(!$cc_holder){$cc_holder=$order->billing['firstname'] . ' ' . $order->billing['lastname'];}

    $book_info = str_replace('$BOOKINFO', MODULE_PAYMENT_NOVALNET_CC_BOOK_REF, MODULE_PAYMENT_NOVALNET_CC_TEXT_BOOKING_INFO);

    $expires_month[] = array ('id' => '', 'text' => MODULE_PAYMENT_NOVALNET_CC_TEXT_SELECT);
    for ($i = 1; $i < 13; $i ++)
    {
       $expires_month[] = array ('id' => sprintf('%02d', $i), 'text' => strftime('%B', mktime(0, 0, 0, $i, 1, 2000)));
    }

    $today = getdate();
    $expires_year[] = array ('id' => '', 'text' => MODULE_PAYMENT_NOVALNET_CC_TEXT_SELECT);
    for ($i = $today['year']; $i < $today['year'] + 10; $i ++)
    {
       $expires_year[] = array ('id' => strftime('%y', mktime(0, 0, 0, 1, 1, $i)), 'text' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)));
    }

    $selection = array('id' => $this->code,
                       'module' => $this->public_title,
                       'fields' => array(array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_CARD_OWNER,
                                               'field' => tep_draw_input_field('cc_holder', $cc_holder, 'id="'.$this->code.'-cc_holder"' . $onFocus),
                                               'tag' => $this->code.'-cc_holder'),
                                         array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_CC_NO,
                                               'field' => tep_draw_input_field('cc_no', $cc_no, 'id="' . $this->code . '-cc_no"' . $onFocus),
                                               'tag' => $this->code . '-cc_no'),
                                         array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_EXP_MONTH,
						'field' => tep_draw_pull_down_menu('cc_exp_month', $expires_month, $cc_exp_month, 'id="' . $this->code . '-cc_exp_month"' . $onFocus),
                                                'tag' => $this->code . '-cc_exp_month'),
                                         array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_EXP_YEAR,
						'field' => tep_draw_pull_down_menu('cc_exp_year', $expires_year, $cc_exp_year, 'id="' . $this->code . '-cc_exp_year"' . $onFocus),  
                                                'tag' => $this->code . '-cc_exp_year'),
                                         array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_CVC,
                                                'field' => tep_draw_input_field('cc_cvc2', $cc_cvc2, 'id="' . $this->code . '-cc_cvc2"' . $onFocus. 'maxlength=3').MODULE_PAYMENT_NOVALNET_CC_TEXT_CVC2.$book_info,
                                                'tag' => $this->code . '-cc_cvc2')
                               ));

    if(function_exists(get_percent))
    {
        $selection['module_cost'] = $GLOBALS['ot_payment']->get_percent($this->code);
    }

    return $selection;
  }

  ### Precheck to Evaluate the Bank Datas ###
  function pre_confirmation_check() {
    global $HTTP_POST_VARS, $_POST;

    $error = '';

    if(count($HTTP_POST_VARS)==0 || $HTTP_POST_VARS=='') $HTTP_POST_VARS = $_POST;

    $error = '';

    if(!MODULE_PAYMENT_NOVALNET_CC_VENDOR_ID || !MODULE_PAYMENT_NOVALNET_CC_AUTH_CODE || !MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID || !MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID)
    {
      $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_NN_MISSING;
    }
    elseif(!$HTTP_POST_VARS['cc_holder'] || strlen($HTTP_POST_VARS['cc_holder'])<MODULE_PAYMENT_NOVALNET_CC_TEXT_CARD_OWNER_LENGTH) $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_CARD_OWNER;
    elseif(!$HTTP_POST_VARS['cc_no'] || strlen($HTTP_POST_VARS['cc_no'])<MODULE_PAYMENT_NOVALNET_CC_TEXT_CC_NO_LENGTH) $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_CC_NO;
    elseif(!$HTTP_POST_VARS['cc_exp_month'] || strlen($HTTP_POST_VARS['cc_exp_month'])<MODULE_PAYMENT_NOVALNET_CC_TEXT_EXP_MONTH_LENGTH) $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_EXP_MONTH;
    elseif(!$HTTP_POST_VARS['cc_exp_year'] || strlen($HTTP_POST_VARS['cc_exp_year'])<MODULE_PAYMENT_NOVALNET_CC_TEXT_EXP_YEAR_LENGTH) $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_EXP_YEAR;
    elseif(!$HTTP_POST_VARS['cc_cvc2'] || strlen($HTTP_POST_VARS['cc_cvc2'])<MODULE_PAYMENT_NOVALNET_CC_TEXT_CVC_LENGTH) $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_CVC;
    elseif($HTTP_POST_VARS['cc_cvc2']=='000' || $HTTP_POST_VARS['cc_cvc2']<1) $error = MODULE_PAYMENT_NOVALNET_CC_TEXT_JS_CVC2;

    $_SESSION['cc_holder'] = $HTTP_POST_VARS['cc_holder'];
    $_SESSION['cc_no'] = $HTTP_POST_VARS['cc_no'];
    $_SESSION['cc_exp_month'] = $HTTP_POST_VARS['cc_exp_month'];
    $_SESSION['cc_exp_year'] = $HTTP_POST_VARS['cc_exp_year'];
    $_SESSION['cc_cvc2'] = $HTTP_POST_VARS['cc_cvc2'];
    
    if($error!='') {
      $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error);
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }
  }

  ### Display Bank Information on the Checkout Confirmation Page ###
  // @return array
  function confirmation() {
    global $HTTP_POST_VARS, $_POST;
    if(count($HTTP_POST_VARS)==0 || $HTTP_POST_VARS=='') $HTTP_POST_VARS = $_POST;

    $confirmation = array('fields' => array(array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_CARD_OWNER,
                          'field' => $HTTP_POST_VARS['cc_holder']),
                    array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_CC_NO,
                          'field' => $HTTP_POST_VARS['cc_no']),
                    array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_EXP_MONTH,
                           'field' => $HTTP_POST_VARS['cc_exp_month']),
                    array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_EXP_YEAR,
                           'field' => $HTTP_POST_VARS['cc_exp_year']),
                    array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_CVC,
                           'field' => '***')
                          ));

    return $confirmation;
  }

  ### Build the data and actions to process when the "Submit" button is pressed on the order-confirmation screen. ###
  ### These are hidden fields on the checkout confirmation page ###
  // @return string
  function process_button() {
    global $HTTP_POST_VARS, $_POST;
    if(count($HTTP_POST_VARS)==0 || $HTTP_POST_VARS=='') $HTTP_POST_VARS = $_POST;

    $process_button_string = tep_draw_hidden_field('cc_holder', $HTTP_POST_VARS['cc_holder']) .
                             tep_draw_hidden_field('cc_no', $HTTP_POST_VARS['cc_no']) .
                             tep_draw_hidden_field('cc_exp_month', $HTTP_POST_VARS['cc_exp_month']) .
                             tep_draw_hidden_field('cc_exp_year', $HTTP_POST_VARS['cc_exp_year']) .
                             tep_draw_hidden_field('cc_cvc2', $HTTP_POST_VARS['cc_cvc2']);

    return $process_button_string;
  }

  ### Store the BANK info to the order ###
  ### This sends the data to the payment gateway for processing and Evaluates the Bankdatas for acceptance and the validity of the Bank Details ###
  function before_process() {
    global $HTTP_POST_VARS, $_POST, $order, $currencies, $customer_id;
    if(count($HTTP_POST_VARS)==0 || $HTTP_POST_VARS=='') $HTTP_POST_VARS = $_POST;

    #Get the required additional customer details from DB
    $customer_query = tep_db_query("SELECT customers_gender, customers_dob, customers_fax FROM ". TABLE_CUSTOMERS . " WHERE customers_id='". (int)$customer_id ."'");
    $customer = tep_db_fetch_array($customer_query);

    list($customer['customers_dob'], $extra) = explode(' ', $customer['customers_dob']);

    ### Process the payment to paygate ##
    $url = 'https://payport.novalnet.de/paygate.jsp';
    $amount = $order->info['total'];
    if (preg_match('/[^\d\.]/', $amount) or !$amount){
      ### $amount contains some unallowed chars or empty ###
      $err                      = '$amount ('.$amount.') is empty or has a wrong format';
      $order->info['comments'] .= '. Novalnet Error Message : '.$err;
      $payment_error_return     = 'payment_error='.$this->code.'&error='.$err;
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }
    $amount = sprintf("%0.2f", $amount);
    $amount = str_replace('.', '', $amount);

    $product_id = MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID;
    $tariff_id = MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID;
    $manual_check_limit = trim(MODULE_PAYMENT_NOVALNET_CC_MANUAL_CHECK_LIMIT);
    $manual_check_limit = str_replace(',', '', $manual_check_limit);
    $manual_check_limit = str_replace('.', '', $manual_check_limit);

    if($manual_check_limit && $amount>=$manual_check_limit)
    {
        $product_id = MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID2;
        $tariff_id = MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID2;
    }

    $user_ip = $this->getRealIpAddr();

    $urlparam = 'vendor='.MODULE_PAYMENT_NOVALNET_CC_VENDOR_ID.'&product='.$product_id.'&key=6&tariff='.$tariff_id.'&auth_code='.MODULE_PAYMENT_NOVALNET_CC_AUTH_CODE.'&currency='.$order->info['currency'];
    $urlparam .= '&amount='.$amount.'&cc_holder='.utf8_encode($HTTP_POST_VARS['cc_holder']).'&cc_no='.$HTTP_POST_VARS['cc_no'];
    $urlparam .= '&cc_exp_month='.$HTTP_POST_VARS['cc_exp_month'].'&cc_exp_year='.$HTTP_POST_VARS['cc_exp_year'];
    $urlparam .= '&cc_cvc2='.$HTTP_POST_VARS['cc_cvc2'].'&first_name='.utf8_encode($order->customer['firstname']).'&last_name='.utf8_encode($order->customer['lastname']);
    $urlparam .= '&street='.utf8_encode($order->customer['street_address']).'&city='.utf8_encode($order->customer['city']).'&zip='.$order->customer['postcode'];
    $urlparam .= '&country='.$order->customer['country']['iso_code_2'].'&email='.$order->customer['email_address'];
    $urlparam .= '&search_in_street=1&tel='.$order->customer['telephone'].'&remote_ip='.$user_ip;
    $urlparam .= '&gender='.$customer['customers_gender'].'&birth_date='.$customer['customers_dob'].'&fax='.$customer['customers_fax'];
    $urlparam .= '&language='.MODULE_PAYMENT_NOVALNET_CC_TEXT_LANG;

    list($errno, $errmsg, $data) = $this->perform_https_request($url, $urlparam);
   
    $aryResponse = array();
    #capture the result and message and other parameters from response data '$data' in an array
    $aryPaygateResponse = explode('&', $data);
    foreach($aryPaygateResponse as $key => $value)
    {
       if($value!="")
       {
          $aryKeyVal = explode("=",$value);
          $aryResponse[$aryKeyVal[0]] = $aryKeyVal[1];
       }
    }

    if($aryResponse['status']==100)
    {
      ### Passing through the Transaction ID from Novalnet's paygate into order-info ###
      $order->info['comments'] .= '. Novalnet Transaction ID : '.$aryResponse['tid'];
    }
    else
    {
      ### Passing through the Error Response from Novalnet's paygate into order-info ###
      $order->info['comments'] .= '. Novalnet Error Code : '.$aryResponse['status'].', Novalnet Error Message : '.$aryResponse['status_desc'];

      $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($aryResponse['status_desc']);

      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }

  }

  ### Realtime accesspoint for communication to the Novalnet payport ###
  function perform_https_request($url, $urlparam){
    global $globaldebug;

    ## requrl: the URL executed later on 
    if ($globaldebug) print "<BR>perform_https_request: $url<BR>\n\r\n";
    if ($globaldebug) print "perform_https_request: $urlparam<BR>\n\r\n";
    
    ## some prerquisites for the connection
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);  // a non-zero parameter tells the library to do a regular HTTP post.
    curl_setopt($ch, CURLOPT_POSTFIELDS, $urlparam);  // add POST fields
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);  // don't allow redirects
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  // return into a variable
    curl_setopt($ch, CURLOPT_TIMEOUT, 240);  // maximum time, in seconds, that you'll allow the CURL functions to take
    
    ## establish connection
    $data = curl_exec($ch);
    
    ## determine if there were some problems 
    $errno = curl_errno($ch);
    $errmsg = curl_error($ch);

    ###bug fix for PHP 4.1.0/4.1.2 (curl_errno() returns high negative value in case of successful termination)
    if ($errno < 0) $errno = 0;
    ## bug fix for PHP 4.1.0/4.1.2 

    if($globaldebug) {
      print_r(curl_getinfo($ch));
      echo "<BR><BR>\n\n\nperform_https_request: cURL error number:" . $errno . "<BR>\n";
      echo "\n\n\nperform_https_request: cURL error:" . $error . "<BR>\n";
    }

    # close connection 
    curl_close($ch);
    ## read and return data from novalnet payport 
    if ($globaldebug) print "<BR>\n" . $data;

    return array ($errno, $errmsg, $data);
    
  }

  function isPublicIP($value)
  {
        if(!$value || count(explode('.',$value))!=4) return false;
        return !preg_match('~^((0|10|172\.16|192\.168|169\.254|255|127\.0)\.)~', $value);
  }

  ### get the real Ip Adress of the User ###
  function getRealIpAddr()
  {
        if($this->isPublicIP($_SERVER['HTTP_X_FORWARDED_FOR'])) return $_SERVER['HTTP_X_FORWARDED_FOR'];
        if($iplist=explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']))
        {
            if($this->isPublicIP($iplist[0])) return $iplist[0];
        }
        if ($this->isPublicIP($_SERVER['HTTP_CLIENT_IP'])) return $_SERVER['HTTP_CLIENT_IP'];
        if ($this->isPublicIP($_SERVER['HTTP_X_CLUSTER_CLIENT_IP'])) return $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
        if ($this->isPublicIP($_SERVER['HTTP_FORWARDED_FOR']) ) return $_SERVER['HTTP_FORWARDED_FOR'];

        return $_SERVER['REMOTE_ADDR'];
  }
 
  ### Send additional information about credit card data via email to the store owner ###
  ### not in use ###
  function after_process() {
    return false;
  }

  ### Used to display error message details ###
  // @return array
  function get_error() {
    global $HTTP_GET_VARS;

    $error = array('title' => MODULE_PAYMENT_NOVALNET_CC_TEXT_ERROR,
                   'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

    return $error;
  }

  ### Check to see whether module is installed ###
  // @return boolean
  function check() {
    if (!isset($this->_check)) {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_NOVALNET_CC_STATUS'");
      $this->_check = tep_db_num_rows($check_query);
    }
    return $this->_check;
  }

  ### Install the payment module and its configuration settings ###
  function install() {
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable CC Module', 'MODULE_PAYMENT_NOVALNET_CC_STATUS', 'True', 'Do you want to activate the Credit Card Payment Method(CC) of Novalnet AG?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Please contact sales@novalnet.de if you do not have any of the following Novalnet IDs!<BR><P>Wenn Sie keine oder irgendeine der folgende Novalnet IDs nicht haben, bitte an sales@novalnet.de wenden!<BR><P>Novalnet Merchant ID', 'MODULE_PAYMENT_NOVALNET_CC_VENDOR_ID', '', 'Your Merchant ID of Novalnet', '6', '2', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Authorisation Code', 'MODULE_PAYMENT_NOVALNET_CC_AUTH_CODE', '', 'Your Authorisation Code of Novalnet', '6', '3', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Product ID', 'MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID', '', 'Your Product ID of Novalnet', '6', '4', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Tariff ID', 'MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID', '', 'Your Tariff ID of Novalnet', '6', '5', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Booking Amount Limit', 'MODULE_PAYMENT_NOVALNET_CC_MANUAL_CHECK_LIMIT', '', 'The amount from which the manual booking control should occur', '6', '6', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Product ID2', 'MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID2', '', 'Your 2nd Product ID of Novalnet', '6', '7', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Tariff ID2', 'MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID2', '', 'Your 2nd Tariff ID of Novalnet', '6', '8', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Enduser Info to be displayed', 'MODULE_PAYMENT_NOVALNET_CC_BOOK_REF', '', 'The Booking Reference Info, which should be displayed to the enduser', '6', '9', now())");   
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_NOVALNET_CC_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '10', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_NOVALNET_CC_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '11', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_NOVALNET_CC_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '12', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
  }
   
  ### Remove the module and all its settings ###
  function remove() {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }

  ### Internal list of configuration keys used for configuration of the module ###
  // @return array
  function keys() {
    return array('MODULE_PAYMENT_NOVALNET_CC_STATUS', 'MODULE_PAYMENT_NOVALNET_CC_VENDOR_ID', 'MODULE_PAYMENT_NOVALNET_CC_AUTH_CODE', 'MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID', 'MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID', 'MODULE_PAYMENT_NOVALNET_CC_MANUAL_CHECK_LIMIT', 'MODULE_PAYMENT_NOVALNET_CC_PRODUCT_ID2', 'MODULE_PAYMENT_NOVALNET_CC_TARIFF_ID2', 'MODULE_PAYMENT_NOVALNET_CC_BOOK_REF', 'MODULE_PAYMENT_NOVALNET_CC_SORT_ORDER', 'MODULE_PAYMENT_NOVALNET_CC_ORDER_STATUS_ID', 'MODULE_PAYMENT_NOVALNET_CC_ZONE');
  }


}

?>
