<?php

#########################################################
#                                                       #
#  ELV_AT / DIRECT DEBIT payment method class           #
#  This module is used for real time processing of      #
#  Austrian Bankdata of customers.                      #
#                                                       #
#  Copyright (c) 2009 Novalnet AG                       #
#                                                       #
#  Released under the GNU General Public License        #
#  Novalnet_elv_at module Created By Dixon Rajdaniel    #
#  This free contribution made by request.              #
#  If you have found this script usefull a small        #
#  recommendation as well as a comment on merchant form #
#  would be greatly appreciated.                        #
#                                                       #
#  Version : novalnet_elv_at.php vOscAT1.3.1 2009-03-01 #
#                                                       #
#########################################################

class novalnet_elv_at {


  var $code;
  var $title;
  var $description;
  var $enabled;

  function novalnet_elv_at() {
    global $order;

    $this->code = 'novalnet_elv_at';
    $this->title = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_TITLE;
    $this->public_title = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_PUBLIC_TITLE;
    $this->description = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_PAYMENT_NOVALNET_ELV_AT_SORT_ORDER;
    $this->enabled = ((MODULE_PAYMENT_NOVALNET_ELV_AT_STATUS == 'True') ? true : false);

    if ((int)MODULE_PAYMENT_NOVALNET_ELV_AT_ORDER_STATUS_ID > 0) {
      $this->order_status = MODULE_PAYMENT_NOVALNET_ELV_AT_ORDER_STATUS_ID;
    }

    if (is_object($order)) $this->update_status();
  }
  
  ### calculate zone matches and flag settings to determine whether this module should display to customers or not ###
  function update_status() {
    global $order;

    if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_NOVALNET_ELV_AT_ZONE > 0) ) {
      $check_flag = false;
      $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_NOVALNET_ELV_AT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    }
  }
  
  ### JS validation which does error-checking of data-entry if this module is selected for use ###
  ### the fields to be cheked are (Bank Owner, Bank Account Number and Bank Code Lengths)      ###
  ### currently this function is not in use ###
  // @return string
  function javascript_validation() {
    return false;
  }
  
  ### Builds set of input fields for collecting Bankdetail info ###
  // @return array
  function selection() {
    global $order, $HTTP_POST_VARS;

    $onFocus = '';

    $bank_account = $HTTP_POST_VARS['bank_account_at'];
    if(!$bank_account){$bank_account=$_SESSION['bank_account_at'];}
    $bank_code = $HTTP_POST_VARS['bank_code_at'];
    if(!$bank_code){$bank_code=$_SESSION['bank_code_at'];}
    $bank_account_holder = $HTTP_POST_VARS['bank_account_holder_at'];
    if(!$bank_account_holder){$bank_account_holder=$_SESSION['bank_account_holder_at'];}
    if(!$bank_account_holder){$bank_account_holder=$order->billing['firstname'] . ' ' . $order->billing['lastname'];}

    $selection = array('id' => $this->code,
                       'module' => $this->public_title,
                       'fields' => array(array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_ACCOUNT_OWNER,
                                               'field' => tep_draw_input_field('bank_account_holder_at', $bank_account_holder, 'id="'.$this->code.'-bank_account_holder_at"' . $onFocus),
                                               'tag' => $this->code.'-bank_account_holder_at'),
                                         array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_ACCOUNT_NUMBER,
                                               'field' => tep_draw_input_field('bank_account_at', $bank_account_at, 'id="' . $this->code . '-bank_account_at"' . $onFocus),
                                               'tag' => $this->code . '-bank_account_at'),
                                         array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_CODE,
            					'field' => tep_draw_input_field('bank_code_at', $bank_code_at, 'id="' . $this->code . '-bank_code_at"' . $onFocus),
						'tag' => $this->code . '-bank_code_at'),
                                 #array('title' => 'INFO:', 'field' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_CUST_INFORM),
                                         array('title' => '', 'field' => MODULE_PAYMENT_NOVALNET_ELV_AT_INFO)
		               ));

    if(function_exists(get_percent))
    {
        $selection['module_cost'] = $GLOBALS['ot_payment']->get_percent($this->code);
    }

    return $selection;
  }

  ### Precheck to Evaluate the Bank Datas ###
  function pre_confirmation_check() {
    global $HTTP_POST_VARS;

    $error = '';
 
    if(!MODULE_PAYMENT_NOVALNET_ELV_AT_VENDOR_ID || !MODULE_PAYMENT_NOVALNET_ELV_AT_AUTH_CODE || !MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID || !MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID)
    {
      $error = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_JS_NN_MISSING;
    }
    elseif(!$HTTP_POST_VARS['bank_account_holder_at'] || strlen($HTTP_POST_VARS['bank_account_holder_at'])<MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_ACCOUNT_OWNER_LENGTH) $error = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_JS_BANK_ACCOUNT_OWNER;
    elseif(!$HTTP_POST_VARS['bank_account_at'] || strlen($HTTP_POST_VARS['bank_account_at'])<MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_ACCOUNT_NUMBER_LENGTH) $error = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_JS_BANK_ACCOUNT_NUMBER;
    elseif(!$HTTP_POST_VARS['bank_code_at'] || strlen($HTTP_POST_VARS['bank_code_at'])<MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_CODE_LENGTH) $error = MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_JS_BANK_CODE;

    $_SESSION['bank_account_holder_at'] = $HTTP_POST_VARS['bank_account_holder_at'];
    $_SESSION['bank_code_at'] = $HTTP_POST_VARS['bank_code_at'];
    $_SESSION['bank_account_at'] = $HTTP_POST_VARS['bank_account_at'];
    
    if($error!='') {
      $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error);
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }
  }

  ### Display Bank Information on the Checkout Confirmation Page ###
  // @return array
  function confirmation() {
    global $HTTP_POST_VARS;

    $confirmation = array('fields' => array(array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_ACCOUNT_OWNER,
                          'field' => $HTTP_POST_VARS['bank_account_holder_at']),
                    array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_ACCOUNT_NUMBER,
                          'field' => $HTTP_POST_VARS['bank_account_at']),
                    array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_BANK_CODE,
			   'field' => $HTTP_POST_VARS['bank_code_at'])
                          ));

    return $confirmation;
  }

  ### Build the data and actions to process when the "Submit" button is pressed on the order-confirmation screen. ###
  ### These are hidden fields on the checkout confirmation page ###
  // @return string
  function process_button() {
    global $HTTP_POST_VARS;

    $process_button_string = tep_draw_hidden_field('bank_account_holder_at', $HTTP_POST_VARS['bank_account_holder_at']) .
                             tep_draw_hidden_field('bank_account_at', $HTTP_POST_VARS['bank_account_at']) .
                             tep_draw_hidden_field('bank_code_at', $HTTP_POST_VARS['bank_code_at']); 

    return $process_button_string;
  }

  ### Store the BANK info to the order ###
  ### This sends the data to the payment gateway for processing and Evaluates the Bankdatas for acceptance and the validity of the Bank Details ###
  function before_process() {
    global $HTTP_POST_VARS, $order, $currencies, $customer_id;

    #Get the required additional customer details from DB
    $customer_query = tep_db_query("SELECT customers_gender, customers_dob, customers_fax FROM ". TABLE_CUSTOMERS . " WHERE customers_id='". (int)$customer_id ."'");
    $customer = tep_db_fetch_array($customer_query);

    list($customer['customers_dob'], $extra) = explode(' ', $customer['customers_dob']);

    ### Process the payment to paygate ##
    $url = 'https://payport.novalnet.de/paygate.jsp';
    $amount = $order->info['total'];
    if (preg_match('/[^\d\.]/', $amount) or !$amount){
      ### $amount contains some unallowed chars or empty ###
      $err                      = '$amount ('.$amount.') is empty or has a wrong format';
      $order->info['comments'] .= '. Novalnet Error Message : '.$err;
      $payment_error_return     = 'payment_error='.$this->code.'&error='.$err;
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }
    $amount = sprintf("%0.2f", $amount);
    $amount = str_replace('.', '', $amount);

    $product_id = MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID;
    $tariff_id = MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID;
    $manual_check_limit = trim(MODULE_PAYMENT_NOVALNET_ELV_AT_MANUAL_CHECK_LIMIT);
    $manual_check_limit = str_replace(',', '', $manual_check_limit);
    $manual_check_limit = str_replace('.', '', $manual_check_limit);

    if($manual_check_limit && $amount>=$manual_check_limit)
    {
        $product_id = MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID2;
        $tariff_id = MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID2;
    }

    $user_ip = $this->getRealIpAddr();

    $urlparam = 'vendor='.MODULE_PAYMENT_NOVALNET_ELV_AT_VENDOR_ID.'&product='.$product_id.'&key=8&tariff='.$tariff_id.'&auth_code='.MODULE_PAYMENT_NOVALNET_ELV_AT_AUTH_CODE.'&currency='.$order->info['currency'];
    $urlparam .= '&amount='.$amount.'&bank_account_holder='.utf8_encode($HTTP_POST_VARS['bank_account_holder_at']).'&bank_account='.$HTTP_POST_VARS['bank_account_at'];
    $urlparam .= '&bank_code='.$HTTP_POST_VARS['bank_code_at'].'&first_name='.utf8_encode($order->customer['firstname']).'&last_name='.utf8_encode($order->customer['lastname']);
    $urlparam .= '&street='.utf8_encode($order->customer['street_address']).'&city='.utf8_encode($order->customer['city']).'&zip='.$order->customer['postcode'];
    $urlparam .= '&country='.$order->customer['country']['iso_code_2'].'&email='.$order->customer['email_address'];
    $urlparam .= '&search_in_street=1&tel='.$order->customer['telephone'].'&remote_ip='.$user_ip;
    $urlparam .= '&gender='.$customer['customers_gender'].'&birth_date='.$customer['customers_dob'].'&fax='.$customer['customers_fax'];
    $urlparam .= '&language='.MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_LANG;

    list($errno, $errmsg, $data) = $this->perform_https_request($url, $urlparam);

    $aryResponse = array();
    #capture the result and message and other parameters from response data '$data' in an array
    $aryPaygateResponse = explode('&', $data);
    foreach($aryPaygateResponse as $key => $value)
    {
       if($value!="")
       {
          $aryKeyVal = explode("=",$value);
          $aryResponse[$aryKeyVal[0]] = $aryKeyVal[1];
       }
    }

    if($aryResponse['status']==100)
    {
      ### Passing through the Transaction ID from Novalnet's paygate into order-info ###
      $order->info['comments'] .= '. Novalnet Transaction ID : '.$aryResponse['tid'];
    }
    else
    {
      ### Passing through the Error Response from Novalnet's paygate into order-info ###
      $order->info['comments'] .= '. Novalnet Error Code : '.$aryResponse['status'].', Novalnet Error Message : '.$aryResponse['status_desc'];

      $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($aryResponse['status_desc']);

      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }

  }

  ### Realtime accesspoint for communication to the Novalnet payport ###
  function perform_https_request($url, $urlparam){
    global $globaldebug;

    ## requrl: the URL executed later on 
    if ($globaldebug) print "<BR>perform_https_request: $url<BR>\n\r\n";
    if ($globaldebug) print "perform_https_request: $urlparam<BR>\n\r\n";
    
    ## some prerquisites for the connection
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);  // a non-zero parameter tells the library to do a regular HTTP post.
    curl_setopt($ch, CURLOPT_POSTFIELDS, $urlparam);  // add POST fields
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);  // don't allow redirects
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  // return into a variable
    curl_setopt($ch, CURLOPT_TIMEOUT, 240);  // maximum time, in seconds, that you'll allow the CURL functions to take
    
    ## establish connection
    $data = curl_exec($ch);
    
    ## determine if there were some problems 
    $errno = curl_errno($ch);
    $errmsg = curl_error($ch);

    ###bug fix for PHP 4.1.0/4.1.2 (curl_errno() returns high negative value in case of successful termination)
    if ($errno < 0) $errno = 0;
    ## bug fix for PHP 4.1.0/4.1.2 

    if($globaldebug) {
      print_r(curl_getinfo($ch));
      echo "<BR><BR>\n\n\nperform_https_request: cURL error number:" . $errno . "<BR>\n";
      echo "\n\n\nperform_https_request: cURL error:" . $error . "<BR>\n";
    }

    # close connection 
    curl_close($ch);
    ## read and return data from novalnet payport 
    if ($globaldebug) print "<BR>\n" . $data;

    return array ($errno, $errmsg, $data);
    
  }

  function isPublicIP($value)
  {
        if(!$value || count(explode('.',$value))!=4) return false;
        return !preg_match('~^((0|10|172\.16|192\.168|169\.254|255|127\.0)\.)~', $value);
  }

  ### get the real Ip Adress of the User ###
  function getRealIpAddr()
  {
        if($this->isPublicIP($_SERVER['HTTP_X_FORWARDED_FOR'])) return $_SERVER['HTTP_X_FORWARDED_FOR'];
        if($iplist=explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']))
        {
            if($this->isPublicIP($iplist[0])) return $iplist[0];
        }
        if ($this->isPublicIP($_SERVER['HTTP_CLIENT_IP'])) return $_SERVER['HTTP_CLIENT_IP'];
        if ($this->isPublicIP($_SERVER['HTTP_X_CLUSTER_CLIENT_IP'])) return $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
        if ($this->isPublicIP($_SERVER['HTTP_FORWARDED_FOR']) ) return $_SERVER['HTTP_FORWARDED_FOR'];

        return $_SERVER['REMOTE_ADDR'];
  }

  ### Send additional information about bankdata via email to the store owner ###
  ### not in use ###
  function after_process() {
    return false;
  }

  ### Used to display error message details ###
  // @return array
  function get_error() {
    global $HTTP_GET_VARS;

    $error = array('title' => MODULE_PAYMENT_NOVALNET_ELV_AT_TEXT_ERROR,
                   'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

    return $error;
  }

  ### Check to see whether module is installed ###
  // @return boolean
  function check() {
    if (!isset($this->_check)) {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_NOVALNET_ELV_AT_STATUS'");
      $this->_check = tep_db_num_rows($check_query);
    }
    return $this->_check;
  }

  ### Install the payment module and its configuration settings ###
  function install() {
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable ELV-AT Module', 'MODULE_PAYMENT_NOVALNET_ELV_AT_STATUS', 'True', 'Do you want to activate the Austrian Direct Debit Method(ELV-AT) of Novalnet AG?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Please contact sales@novalnet.de if you do not have any of the following Novalnet IDs!<BR><P>Wenn Sie keine oder irgendeine der folgende Novalnet ID nicht haben, bitte an sales@novalnet.de wenden!<BR><P>Novalnet Merchant ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_VENDOR_ID', '', 'Your Merchant ID of Novalnet', '6', '2', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Authorisation Code', 'MODULE_PAYMENT_NOVALNET_ELV_AT_AUTH_CODE', '', 'Your Authorisation Code of Novalnet', '6', '3', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Product ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID', '', 'Your Product ID of Novalnet', '6', '4', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Tariff ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID', '', 'Your Tariff ID of Novalne', '6', '5', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Booking Amount Limit', 'MODULE_PAYMENT_NOVALNET_ELV_AT_MANUAL_CHECK_LIMIT', '', 'The amount from which the manual booking control should occur', '6', '6', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Product ID2', 'MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID2', '', 'Your 2nd Product ID of Novalnet', '6', '7', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Novalnet Tariff ID2', 'MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID2', '', 'Your 2nd Tariff ID of Novalnet', '6', '8', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Enduser Info to be displayed', 'MODULE_PAYMENT_NOVALNET_ELV_AT_INFO', '', 'The Info which should be displayed to the enduser', '6', '9', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_NOVALNET_ELV_AT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '10', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_NOVALNET_ELV_AT_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '11', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_NOVALNET_ELV_AT_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '12', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
  }
   
  ### Remove the module and all its settings ###
  function remove() {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }

  ### Internal list of configuration keys used for configuration of the module ###
  // @return array
  function keys() {
    return array('MODULE_PAYMENT_NOVALNET_ELV_AT_STATUS', 'MODULE_PAYMENT_NOVALNET_ELV_AT_VENDOR_ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_AUTH_CODE', 'MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_MANUAL_CHECK_LIMIT', 'MODULE_PAYMENT_NOVALNET_ELV_AT_PRODUCT_ID2', 'MODULE_PAYMENT_NOVALNET_ELV_AT_TARIFF_ID2', 'MODULE_PAYMENT_NOVALNET_ELV_AT_INFO', 'MODULE_PAYMENT_NOVALNET_ELV_AT_SORT_ORDER', 'MODULE_PAYMENT_NOVALNET_ELV_AT_ORDER_STATUS_ID', 'MODULE_PAYMENT_NOVALNET_ELV_AT_ZONE');
  }


}

?>
